{***************************************************************************}
{  Date: 24.10.98                                            Time: 17:30:40 }
{  Copyright (c)1996-1998                                                   }
{   by Dr.Plass                                      Demo zu  TFindWin4.0  }
{                                                                           }
{                                              for DELPHI 3/4, Win95/98     }
{  feel free to contact me:                                                 }
{  Peter.Plass@FH-Zwickau.de                                                }
{  http://www.fh-zwickau.de/~pp/tm.htm                                      }
{                                                                           }
{                                                                           }
{***************************************************************************}


unit FListWin;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, Buttons, Findwin, ExtCtrls, ComCtrls, FileCtrl, Menus;

type
   TForm1 = class(TForm)
      ListBox1    : TListBox;
      BitBtn1     : TBitBtn;
      BitBtn2     : TBitBtn;
      BitBtn3     : TBitBtn;
      BitBtn4     : TBitBtn;
      CheckBox1   : TCheckBox;
      CheckBox2   : TCheckBox;
      CheckBox3   : TCheckBox;
      WinList1    : TWinList;
      GroupBox1   : TGroupBox;
      cb1: TCheckBox;
      cb2: TCheckBox;
      cb3: TCheckBox;
      cb4: TCheckBox;
      cb5: TCheckBox;
      cb6: TCheckBox;
      cb7: TCheckBox;
      cb8: TCheckBox;
      cb9: TCheckBox;
      cb10: TCheckBox;
      cb11: TCheckBox;
      cb12: TCheckBox;
      cb13: TCheckBox;
      cb14: TCheckBox;
      cb15: TCheckBox;
      cb16: TCheckBox;
      cb17: TCheckBox;
      cb18: TCheckBox;
      cb19: TCheckBox;
      cb20: TCheckBox;
      Panel1: TPanel;
      Label1: TLabel;
      Label7: TLabel;
      Label6: TLabel;
      Label5: TLabel;
      Label2: TLabel;
      cb21    : TCheckBox;
      cb22    : TCheckBox;
      BitBtn5 : TBitBtn;
      Label8  : TLabel;
      Image1  : TImage;
      BitBtn6: TBitBtn;
      Label4: TLabel;
      PopupMenu1: TPopupMenu;
      TerminateProcess1: TMenuItem;
      Refresh1: TMenuItem;
      About1: TMenuItem;
      N1: TMenuItem;
      Close1: TMenuItem;
      Label3: TLabel;
      StaticText1: TStaticText;
    Switchto1: TMenuItem;

      procedure SetStyle(sty:LongInt);
      procedure BitBtn1Click(Sender: TObject);
      procedure BitBtn4Click(Sender: TObject);
      procedure ListWin(Sender: TObject);
      procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
      procedure CheckBox3Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure BitBtn5Click(Sender: TObject);
      procedure BitBtn6Click(Sender: TObject);
      procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
      procedure DoWindow;
      procedure TerminateProcess1Click(Sender: TObject);
      procedure Refresh1Click(Sender: TObject);
      procedure ListBox1DblClick(Sender: TObject);
   private
{ Private-Deklarationen }
   public
{ Public-Deklarationen }
   end;

var
   Form1: TForm1;
   ico  : TIcon;
implementation
{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   WinList1.TaskBarSty := Checkbox2.checked;
   if checkbox2.checked then begin
      checkbox1.checked := False;
      checkbox1.enabled := False;
   end else
      checkbox1.enabled := True;
   WinList1.EmptyNames:= Checkbox1.checked;

   if Sender = BitBtn1 then WinList1.WhatDoFind := id_all;
   if Sender = BitBtn2 then WinList1.WhatDoFind := id_visonly;
   if Sender = BitBtn3 then WinList1.WhatDoFind := id_invisonly;
   WinList1.Execute;
   ListWin(Sender);
end;

procedure TForm1.ListWin(Sender: TObject);
begin
   ListBox1.Clear;
   ListBox1.Items.Assign(WinList1.WindowList);
   ListBox1.ItemIndex := 0;
   SetStyle(0);
   Label3.Caption := IntToStr(ListBox1.Items.count) + ' window(s) found  ';
   Label6.Caption := '';
   Label7.Caption := 'klick an item to obtain some information';
   Label5.caption := '';
   Label2.caption := '';
   Label4.caption:= '';
   Label8.Caption := '';
   Image1.Picture.Icon := Nil;
   DoWindow;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
   close;
   if ico <> nil then ico.free;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
Shift: TShiftState; X, Y: Integer);
begin
   DoWindow;
end;

procedure TForm1.DoWindow;
var
   hdlp,
   whdl  : HWnd;
   thdl  : HTask;
   phdl  : DWORD;
   wsty,
   wXty  : LongInt;
begin
   if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
   Image1.Picture.Icon := nil;
   ico  := TIcon.Create;
   whdl := WinList1.GetWinHandle(ListBox1.ItemIndex);
   hdlp := WinList1.GetWinParent(ListBox1.ItemIndex);
   thdl := WinList1.GetThreadID(ListBox1.ItemIndex);
   phdl := WinList1.GetProcessID(ListBox1.ItemIndex);
   wsty := WinList1.GetWinStyle(ListBox1.ItemIndex);
   wxty := WinList1.GetWinExStyl(ListBox1.ItemIndex);

   Label1.Caption := 'HWnd:      ' + IntToHex(whdl,4);
   Label7.Caption := 'ThreadID:  ' + IntToHEX(thdl,4)+
   ' / ProcessID: ' + IntToHEX(phdl,4);
   Label6.Caption := 'HParent:   ' + IntToHex(hdlp,4) +
   ' -> '+WinList1.GetParentName(ListBox1.ItemIndex);
   Label5.Caption := 'ClassName: ' + WinList1.GetWnClasName(ListBox1.ItemIndex);
   Label2.Caption := 'WinStyle:  ' + IntToHex(wsty,4)+
   ' / WinExSty: ' + IntToHEX(wxty,4);
   Label4.Caption:= MiniMizeName(WinList1.GetWinExePath(ListBox1.ItemIndex),Canvas,Label4.Width);
   Label8.Caption := 'HIcon: ' + IntToHex(WinList1.GetIconHandle(ListBox1.ItemIndex),4);
   ico.Handle     := WinList1.GetIconHandle(ListBox1.ItemIndex);

   Image1.Picture.Icon := ico;
   SetStyle(wsty);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
   WinList1.EnableTimer := CheckBox3.checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Caption    := WinList1.About;
   CheckBox1.Checked := WinList1.EmptyNames;
   CheckBox3.Checked := WinList1.EnableTimer;
   CheckBox2.Checked := WinList1.TaskBarSty;
end;

procedure TForm1.SetStyle(sty:LongInt);
begin
   if sty = 0 then  cb1.checked := False
   else
      cb1.checked := (sty AND WS_OVERLAPPED) = WS_OVERLAPPED;
   cb2.checked := (sty AND WS_POPUP) = WS_POPUP;
   cb3.checked := (sty AND WS_CHILD) = WS_CHILD;
   cb4.checked := (sty AND WS_MINIMIZE) = WS_MINIMIZE;
   cb5.checked := (sty AND WS_VISIBLE) = WS_VISIBLE;
   cb6.checked := (sty AND WS_DISABLED) = WS_DISABLED;
   cb7.checked := (sty AND WS_CLIPSIBLINGS) = WS_CLIPSIBLINGS;
   cb8.checked := (sty AND WS_CLIPCHILDREN) = WS_CLIPCHILDREN;
   cb9.checked := (sty AND WS_MAXIMIZE) = WS_MAXIMIZE;
   cb10.checked := (sty AND WS_CAPTION) = WS_CAPTION;
   cb11.checked := (sty AND WS_BORDER) = WS_BORDER;
   cb12.checked := (sty AND WS_DLGFRAME) = WS_DLGFRAME;
   cb13.checked := (sty AND WS_VSCROLL) = WS_VSCROLL;
   cb14.checked := (sty AND WS_HSCROLL) = WS_HSCROLL;
   cb15.checked := (sty AND WS_SYSMENU) = WS_SYSMENU;
   cb16.checked := (sty AND WS_THICKFRAME) = WS_THICKFRAME;
   cb17.checked := (sty AND WS_GROUP) = WS_GROUP;
   cb18.checked := (sty AND WS_TABSTOP) = WS_TABSTOP;
   cb19.checked := (sty AND WS_MINIMIZEBOX) = WS_MINIMIZEBOX;
   cb20.checked := (sty AND WS_MAXIMIZEBOX) = WS_MAXIMIZEBOX;
   cb21.checked := (sty AND WS_TILEDWINDOW) = WS_TILEDWINDOW;
   cb22.checked := (sty AND WS_POPUPWINDOW) = WS_POPUPWINDOW;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
   MessageDlg('Demosoftware'+ #10#13+
   'for the Componente: TFindWin4.0 [32]     '+ #10#13+ #10#13+
   ' 1996-1998 by Dr.Plass              '+ #10#13+
   'Peter.Plass@fh-zwickau.de            '+ #10#13+
   'http://www.fh-zwickau.de/~pp/tm.htm  ',
   mtInformation, [mbOk],0);
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
   CheckBox3.checked:=true;
   CheckBox3Click(Sender);
   Winexec('notepad.exe',SW_SHOWMINIMIZED);
end;

procedure TForm1.ListBox1KeyUp(Sender: TObject; var Key: Word;
Shift: TShiftState);
begin
   DoWindow;
end;

procedure TForm1.TerminateProcess1Click(Sender: TObject);
const
   PROCESS_TERMINATE = 1;
var
   ProcHandle: THandle;
begin
   if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
   if (MessageDlg('Process: --> ' + ListBox1.Items[ListBox1.itemIndex]+ #10#13#10#13+
   'TerminateProcess may lead the system into an instable state! '+#10#13+
   'You should use this function only if you are sure about doing so.'+#10#13+
   'Are You sure?', mtConfirmation, [mbYes, mbNo], 0) = mrYes)
   then begin
      ProcHandle := OpenProcess(PROCESS_TERMINATE, FALSE, DWORD(WinList1.GetProcessID(ListBox1.ItemIndex)));
      try
         if ProcHandle <> 0 then begin
            if TerminateProcess(ProcHandle, $FFFFFFFF) then
               WaitForSingleObject(ProcHandle, INFINITE);
         end else
            MessageDlg('Can not find the handle of the selected prozess!', mtError, [mbOK], 0);
      finally
         CloseHandle(ProcHandle);
      end;
      Refresh1Click(Sender);
   end;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
begin
   WinList1.Execute;
   ListWin(self);
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
whdl:HWnd;
begin
 if (ListBox1.Items.count < 1) OR (ListBox1.ItemIndex < 0) then exit;
  whdl:=WinList1.GetWinHandle(ListBox1.ItemIndex);
  ShowWindow(whdl,SW_RESTORE);
  SetForegroundWindow(whdl);
end;

end.
